/*  PS2Keyboard library, International Keyboard Layout Example
    http://www.pjrc.com/teensy/td_libs_PS2Keyboard.html

    keyboard.begin() accepts an optional 3rd parameter to
    configure the PS2 keyboard layout.  Uncomment the line for
    your keyboard.  If it doesn't exist, you can create it in
    PS2Keyboard.cpp and email paul@pjrc.com to have it included
    in future versions of this library.
*/
   
#include <PS2Keyboard.h>
String ASCII =     " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~"; // bits of the ASCII table relevant, add 46 to index... note the \\ is a delimited '\'. pos 34 \" is delimited "
//                  23 4567890123456789012345678901234567890123456789012345678901 23456789012345678901234567890123456
//                3          4         5         6         7         8         9          0         1         2    
#define DEBUG 2
const int DataPin = 8;
const int IRQpin =  3;

PS2Keyboard keyboard;
 
void setup() {
  //keyboard.begin(DataPin, IRQpin, PS2Keymap_US);
  keyboard.begin(DataPin, IRQpin, PS2Keymap_German);
  Serial.begin(115200);
  Serial.println("International Keyboard Test:");
}

void loop() {
  if (keyboard.available()) {
    int   c = keyboard.read();
    Serial.print(c);
    Serial.print("->");
    Serial.println(charASCII(c));
  }
}
char charASCII(int index){// given an ASCII value, return the ASCII Character
  char chr;
  index = index - 32; // subtract 32 for the array offset, (ie the ASCII array first character is ASCII 32, ie SPACE.)
  chr = ASCII.charAt(index);
  if (DEBUG >= 10){ 
    Serial.println("charASCII: (index) chr = (" + String(index) + ") " + chr);
  }
  return chr;
}
int codeASCII (char chr){ // given a character, return the ASCII code in DEC format
  int index;
  index = ASCII.indexOf(chr);
  index += 32; // add 32 for the array offset, (ie the ASCII array first character is ASCII 32, ie SPACE.)
  if (DEBUG >= 7){ Serial.println("codeASCII: (index) chr = (" + String(index) + ") " + chr);  }
  return index;
}

